
/*
*   Test loop termination check of ProMiX
*/

append([], X, X).
append([X|Xs], Ys, [X|Zs]) :- append(Xs, Ys, Zs).

p1(X, Y).
p1(X, Y) :- p1(s(X), Y).

p2(0).
p2(s(X)) :- p2(X).

member(X, [X|_]).
member(X, [_|T]) :- member(X, T).

nlist(0, []).
nlist(s(X), [_|T]) :- nlist(X, T).


loop_test(1) :-    loop_test_x(append(X,[1,2],Y)).
loop_test(2) :-    loop_test_x(p1(X, Y)).
loop_test(3) :-    loop_test_x(p2(X)).
loop_test(4) :-    loop_test_x(member(X, [1,2|L])).
loop_test(5) :-    loop_test_x(nlist(X, [1,2|L])).

loop_test_x(Goal) :- 
   get_value(loop_check_type, Type),
   writeln(['Loop check type is set to - ', Type, '.']),
   writeln(['Partially evaluating goal - ', Goal]),
   nl,
   mixd(Goal).

loop_test_all_type(Tests) :-
   loop_test_all_type(Tests, 
          [unify,instance,strict_instance,variant,less_general]).

loop_test_all_type(Tests, TestTypes) :-
   member(TestType, TestTypes),
   set_value(loop_check_type, TestType),
   member(Test, Tests),
   loop_test(Test),
   fail.
loop_test_all_type(_Tests, _TestTypes) :-
   writeln(['*** loop testing over ** ']).
