/*
*               HOW TO TEST PROMIX 
*
*      - PRINT OUT THIS FILE FOR REFERENCE
*      - CONSULT FILES as given in the README file
*      - THE FILE CONTAINS FOUR TYPES OF TESTS
*             - program, or_test, if_test, set_test
*      - SELECT THE TEST YOU WOULD LIKE TO DO: say "if_test"
*      - SELECT A TEST NUMBER IN THIS CATEGORY: say 5
*      - PERFORM THE QUERY
*            ?- mixd(if_test(5,X)).
*        *** RESIDUAL CLAUSE(S) WOULD BE DISPLAYED
*      - VERIFY BY INSPECTION IF THE RESIDUE IS CORRECT
*
*   NOTE: THE TEST SET IS NEITHER EXHAUSTIVE, NOR IS IT "SCIENTIFICALLY"
*         CREATED. Contributions test-sets and test-drivers are welcome.
*/


/* KNOWLEDGE FOR DRIVING THESE TESTS */

     should_unfold(int(X)) :- !, integer(X).
     should_unfold(_).  /*  UNFOLD ALL OTHER PREDICATES */
     expand_predicate(X, X).  /*  DO NOT REWRITE PREDICATES */

%% TEST-SET  OVER %%%

run_all_tests :- test_data(X,Y), test_mix(X,Y), fail.

test_mix(Type, Number) :-
    writeln(['**** Test type  ', Type, '   # ', Number, '  ***']),
    Goal =.. [Type,Number,Result],
    mixd(Goal),
    fail.   % print all results
test_mix(_,_) :- nl.

test_data(program, 0).
test_data(program, 1).
test_data(program, 2).
test_data(program, 3).
test_data(program, 4).
test_data(program, 5).
test_data(program, 6).
test_data(program, 7).

test_data(or_test, 1).
test_data(or_test, 2).
test_data(or_test, 3).
test_data(or_test, 4).
test_data(or_test, 5).
test_data(or_test, 6).

/*  PROGRAMS */

test_data(if_test, 1).
test_data(if_test, 2).
test_data(if_test, 3).
test_data(if_test, 4).
test_data(if_test, 5).
test_data(if_test, 6).
test_data(if_test, 7).
test_data(if_test, 8).
test_data(if_test, 9).
test_data(if_test, 10).
test_data(if_test, 11).
test_data(if_test, 12).
test_data(if_test, 13).
test_data(if_test, 14).
test_data(if_test, 15).

/*  SET TESTS  */

test_data(set_test, 1).
test_data(set_test, 2).
test_data(set_test, 3).

