
/*  META-KNOWLEDGE FOR OWEN's LEMMA INTERPRETERS   */

   /* ABOUT THE INTERPRETER GOALS */

   meta_goal(solve(_Theory, Goal), Goal).
   meta_goal(solve_with_lemma(_Theory, Goal, _Goal1), Goal).
   meta_goal(solve_with_x(_Theory, Goal), Goal).

   /* ABOUT THE LANGUAGE PROCESSED */
 
   structure_decomposed((_,_)).
   structure_decomposed(true).

   terminal_atom(X) :- sys(X).

   /* ABOUT THE SUPPORT PREDICATES USED */

   /* !,fail to protect against similar knowledge from previous
      run */

   imperative(_X) :- !,fail.
   export(lemma(_X)).
   export(add_lemma(_X)).

   /*  FOR DRIVER   */

   flavor(lemma, solve(_Theory,_Goal)).
   flavor(lemma, solve_x(_Theory,_Goal)).
   flavor(lemma, solve_with_lemma(_Theory,_Goal, _Goal1)).

  /*  FOR FILE INTERFACE  */
  /* NOTE:  The programs should be stored as a set of owen_member/2 facts */

   rule_head((owen_member(_Theory, (Head :-_Body)):-true), Head).

   generate_functor_name(solve(_,_), ObjGoal, Functor) :-
        ObjGoal =.. [Functor|_ObjArgs].
   generate_functor_name(solve_x(_,_), ObjGoal, Functor_x) :-
        ObjGoal =.. [Functor|_ObjArgs],
	append_atoms(Functor, '_x', Functor_x).
   generate_functor_name(solve_with_lemma(_,_,_), ObjGoal, Functor_x) :-
        ObjGoal =.. [Functor|_ObjArgs],
	append_atoms(Functor, '_wl', Functor_x).


%% END OF META_K.PRO %%%
