
/*
   The "lemma" meta-interpreter from:
      @inproceedings{Owen,
	  AUTHOR= {Owen, S.},
	  TITLE= {Issues in the Partial Evaluation of Meta-Interpreters},
	  BOOKTITLE= {Proceedings {Meta88}: Workshop on Meta-programming in
		       Logic Programming, Bristol},
	  MONTH= Jun,
	  PUBLISHER={MIT Press},
	  YEAR= 1988,
	  PAGES={319-339}
	}

   February 22, 1990

*/

/* 1 */ solve(_Theory, true).
/* 2 */	solve(Theory, not Goal) :-
	    not solve(Theory, Goal).
/* 3 */	solve(_Theory, Goal) :-
	    system(Goal),
	    call(Goal).
/* 4 */	solve(Theory, (Goal,Rest)) :-
	    solve(Theory, Goal),
	    solve(Theory, Rest).
/* 5 */	solve(Theory, Goal) :-
	    uniqueSoln(Theory, Goal, Goal1),
	    lemma(Goal1),
	    !,
	    Goal = Goal1.
/* 6 */	solve(Theory, Goal) :-
	    uniqueSoln(Theory, Goal, _Goal1), !,
	    member(Theory, (Goal:-SubGoals)),
	    solve(Theory, SubGoals),
	    add_lemma(Goal),
	    !.
/* 7 */	solve(Theory, Goal) :-
	    not uniqueSoln(Theory, Goal),
	    member(Theory, (Goal:-SubGoals)),
	    solve(Theory, SubGoals).

/* The clauses are numbered as in the original paper */
