/*
   A transformed version of "preventing resatisfaction" meta-interpreter 
   in file "metai.pro".

   Transformation done by Arun Lakhotia: February 23, 1990

CHANGES DONE TO THE ORIGINAL INTERPRETER

   Goals in the body of clause 5 and 6 folded into a new procedure
     solve_with_lemma/2
   The cuts in these clauses were removed because -- I think lemma/1
     will succeed only once, if at all it does.
   The cut was moved to the end of clause 5. Marked **

   Procedure solve_x/2 created just as in the case of "resatisfacion
     interpreter".

   member/2 predicate renamed to owen_member/2.
   system/2 renamed to sys/2
   introduced cuts to make the clauses mutually exclusive. These cuts
      are marked as ! *new*
      NOTE: sys(true). sys((_,_)). sys(not(_)) are all true hence the
            cuts.


*/


/* 1 */ solve(_Theory, true) :- ! /*new*/.
/* 2 */	solve(Theory, not Goal) :-! /*new*/,
	    not solve(Theory, Goal).
/* 3 */	solve(_Theory, Goal) :-
	    sys(Goal), ! /*new*/,
	    call(Goal).
/* 4 */	solve(Theory, (Goal,Rest)) :- ! /*new*/,
	    solve(Theory, Goal),
	    solve(Theory, Rest).
/* 5 */	solve(Theory, Goal) :-
	    uniqueSoln(Theory, Goal, Goal1),
	    solve_with_lemma(Theory, Goal, Goal1),
            !. /**/
/* 7 */	solve(Theory, Goal) :-
	    not uniqueSoln(Theory, Goal),
	    solve_x(Theory, Goal).

solve_with_lemma(Theory, Goal, Goal1) :-
	    lemma(Goal1),
	    Goal = Goal1.
solve_with_lemma(Theory, Goal, _Goal1) :-
	    solve_x(Theory, Goals),
	    add_lemma(Goal).

solve_x(Theory, Goal) :-
	    owen_member(Theory, (Goal:-SubGoals)),
	    solve(Theory, SubGoals).


/* The clauses are numbered as in the original paper */
