
/*
   A transformed version of "preventing resatisfaction" meta-interpreter 
   in file "metai.pro".

   Transformation done by Arun Lakhotia: February 22, 1990

CHANGES DONE TO THE ORIGINAL INTERPRETER

   Goals in the body of clause 5 and 6 folded into a new procedure
     solve_x/2. 
   member/2 predicate renamed to owen_member/2.
   system/2 renamed to sys/2
   introduced cuts to make the clauses mutually exclusive. These cuts
      are marked as ! *new*
      NOTE: sys(true). sys((_,_)). sys(not(_)) are all true hence the
            cuts.
*/

/* 1 */ solve(_Theory, true) :- ! /*new*/.
/* 2 */	solve(Theory, not Goal) :- !, /*new*/
	    not solve(Theory, Goal).
/* 3 */	solve(_Theory, Goal) :-
	    sys(Goal), 
            ! /*new*/,
	    call(Goal).
/* 4 */	solve(Theory, (Goal,Rest)) :-
	    solve(Theory, Goal),
	    solve(Theory, Rest).
/* 5 */	solve(Theory, Goal) :-
	    uniqueSoln(Theory, Goal),
	    solve_x(Theory, Goal),
	    !.
/* 6 */	solve(Theory, Goal) :-
	    not uniqueSoln(Theory, Goal),
	    solve_x(Theory, Goal).

 solve_x(Theory, Goal) :-
	    owen_member(Theory, (Goal:-SubGoals)),
	    solve(Theory, SubGoals).

/* The clauses are numbered as in the original paper */
