/*

  This program was sent to me (Arun Lakhotia) by Ronen Feldman by
  e-mail for the purpose of experimenting with ProMiX.

    Date: Mon, 2 Jul 90 11:54:41 EDT
    From: feldman@cs.cornell.edu (Ronen Feldman)

  The program has been edited -- moved predicate definitions around,
  made one predicate per line, etc. for the sake of clarity of
  presentation. In the process the interpreter and data part of the
  code has also become explicit

   Arun Lakhotia -- July 2, 1990

*/

%---anc.dom
%---query female_ancestor(a,g)
%---general query female_ancestor(X,Y) , X and Y are any 2 constants
%---answer yes


% INTERPRETER

female_ancestor(X, X) :- 
    female(X).
female_ancestor(X, Y) :-
    mother(X, Z),
    female_ancestor(Z, Y).
female_ancestor(X, Y) :-
    mother(X, Z),
    male_ancestor(Z, Y).

male_ancestor(X, X) :-
    male(X).
male_ancestor(X, Y) :-
    father(X, Z),
    female_ancestor(Z, Y).
male_ancestor(X, Y) :-
    father(X, Z),
    male_ancestor(Z, Y).


% DATA

father(b,c).  father(d,e).  father(f,g).

mother(a,b).  mother(c,d).  mother(e,f).

female(a).  female(c).  female(e).  female(g).

male(b).  male(d).  male(f).
