/* Received the following problem from Ronen Feldman by e-mail.  The
   text of his mail is commented so as to leave only the Prolog code
   outside.
    Arun Lakhotia, Mon Aug 13 12:54:37 CDT 1990
*/

% Return-Path: <feldman@cs.cornell.edu>
% Date: Mon, 13 Aug 90 13:05:31 EDT
% From: feldman@cs.cornell.edu (Ronen Feldman)
% To: arun@cacs.usl.edu
% Subject: problem with promix
% 
% Hi Arun,
% 
% Now I have some more time I'm trying to do some experiments with
% promix.
% I'm dealing with the problem of correcting domain theories. You have a
% domain theory which some of its rules are incorrect.
% 
% One case of incorrectness is if soem rule ahs an extra literal and
% therefore you can't get the expected answer.
% 
% Here is an example I've tried (taken from a paper in AAAI-90) I'm
% giving the concept I want to prove for the specific instance and from
% the proofs the partial evaluator will give me I'll pick the one I want
% and see what parts I can't prove and take it out of the rule.
% 
% Here is the domain theory:

drinking_v :- stable,liftable,open_v.

stable :- has_bottom,flat_bottom.

liftable :- graspable,light_weight.

graspable :- has_handle.
graspable :- small_width,styrofoam,color_blue.
graspable :- small_width,ceramic.

open_v :- has_con,upper_p.

% The specific instance
has_con.
has_bottom.
flat_bottom.
light_weight.
upper_p.
color_yellow.
small_width.
styrofoam.

% Idealy I'd ant to get the following answer:

graspable :- has-handle.
graspable :- color_blue.
graspable :- ceramic.


% Now I can pick what literal I want to discard. In the paper there were
% more examples (negative and positive that ruled 2 possibilities out
% and we were left with color-blue as the only candidate for
% elimination).
% 
% Here is the output I got from promix to the query mixd(graspable).
% --------------------------------------
% 
% | ?- mixd(graspable).
% graspable :- graspable_extension_1.
% 
% 
% graspable_extension_1 :- A.
% 
% 
% graspable_extension_1 :-
%       small_width,
%       styrofoam,
%       color_blue.
% 
% 
% graspable_extension_1 :-
%       small_width,
%       ceramic.
% 
% 
% 
% yes
% |
% -----------------------------------------
% 
% Well 4 problems I can see here:
% 1. why the graspable_extension_1?
% 2. what is the A?
% 3. where is the rule about the has-handle?
% 4. why it left in the residue the small_width,styrofoam which are known
% to be true?
% 
% On trace I saw it had something to do with has_cut this is why it
% produced the extension. As far as I can see 1,2,3 are bugs 4 is
% probably some predicate I should use in order to eliminate
% small_width,styrofoam from the residue. (I just can;t recall now what
% it is)
% 
% Can you help?
% 
% Thanks 
% 
% Ronen

