bagOf(Term,true,[Term]).
bagOf(Term,(Call,Conjunction),List) :- !,
        bagOf((Term,Conjunction),Call,Pairs),
	bagOf_conjunct(Pairs,List). 
bagOf(Term, Call, Terms) :-
	sys(Call),!,
	bagOf_system_predicate(Term, Call, Terms).
bagOf(Term,Call,Terms) :- 
        %  unfolding the clause single_call_set
        all_clauses(Call,Clausebody_pairs),
        bagOf_conjunct(Clausebody_pairs,Solved_calls),!,
	term_instances(Term,Call,Solved_calls,Terms). 
bagOf(Term,Call,[]).

        bagOf_conjunct([],[]).
        bagOf_conjunct([(Term,Conjunction) | Pairs],List) :- 
             bagOf(Term,Conjunction,List1),
             bagOf_conjunct(Pairs,List2),
	     merge(List1,List2,List). 

term_instances(_,_,  [], []).
term_instances(Term,Call,[S | Ss], [R | T]) :- 
        term_instance(Term,Call,S,R), !,
        term_instances(Term,Call,Ss, T). 
term_instances(Term,Call,[S | Ss], T) :- 
       % not term_instance(Term,Call,S,R), 
        term_instances(Term,Call,Ss, T). 

term_instance(Term,Call,Solved_call,Copyterm) :- 
        copy((Term,Call),(Copyterm,Copycall)),
	unify(Copycall,Solved_call).


% all_clauses(Goal, ClauseBodyPairs)
%      where ClauseBodyPairs is a list of (Head, Body)
%            where Head' :- Body' is a clause in the Database
%            and (Head,Body) is the resolvent from unifying
%            Head' with Goal.

all_clauses(Goal, ClauseBodyPairs) :-
      bagof((Goal, Body), clause(Goal, Body), ClauseBodyPairs).

bagOf_system_predicate(Term, Call, Terms) :-
 	bagof(Term, Call, Terms),!.
bagOf_system_predicate(Term, Call, []).

merge(X, Y, Z) :- append(X, Y, Z).
unify(X, Y) :- X = Y.
copy(X, Y) :- asserta('%$copy'(X)), retract('%$copy'(Y)).

x :- reconsult('bagof.pl').
