
/*
*  Support procedures for findall.pro
*  Extracted February, 15, 1990
*/

%% make_diff_list(+List, -Dlist)
%%    Dlist is a difference list, say, SomeList-Suffix
%%    such that unifying Suffix with [], makes SomeList
%%    equal (==) to List.

make_diff_list(Var, Var-Var) :- var(Var),!.
make_diff_list([], Tail-Tail).
make_diff_list([X|Xs], [X|Zs]-Tail) :-
	make_diff_list(Xs, Zs-Tail).


%% all_clauses(+Goal, -ClauseList)
%%      where ClauseList is a list of (Head:- Body)
%%            where Head' :- Body' is a clause in the Database
%%            and (Head :-Body) is the resolvent from unifying
%%            Head' with Goal.

all_clauses(Goal, ClauseList) :-
      bagof((Goal :- Body), unfold_clause(Goal, Body), ClauseList).

%% System specific definitions, to be defined by the user

%% sys(+Goal) <- 
%%    Goal is a system goal, ie, a goal whose clause definition
%%    can not be referenced.
