
/*  A SAMPLE DCG INTERPRETER TO FOR PARTIAL EVALUATION
*/

/* USES ---> INSTEAD OF --.  

  The following :- may create problems when loading this program as
  data using other than consult/compile commands.

  Fix: Remove it from here and perform the op through some other file,
       say the meta_k.pro file
*/

:- current_op(X, Y, -->), op(X, Y, --->).  


/********* A DCG INTERPRETER     ************/
/*
     This interpreter was probably written by Richard O'Keefe
     and posted to comp.lang.prolog sometime in 1987
*/

dcg(Head, Begin, End) :-	/* Note 1 */
        dcg_rule(Head,Body),
	dcg_head(Head),
	dcg_body(Body, Begin, End).

dcg_head(','(NonTerminal,PushBack)) :- !,
	nonterminal(NonTerminal),
	proper_list(PushBack).	/* Note 2 */
dcg_head(NonTerminal) :- /* Note 3 */
	nonterminal(NonTerminal).

dcg_body(Var, Begin, Begin) :- /* Note 4 */
	var(Var),
	!,
        write_error(['Variable encountered in grammar']).
dcg_body(','(And,Then), Begin, End) :- !,
	dcg_body(And, Begin, Middle),
	dcg_body(Then, Middle, End).
dcg_body({Goal}, Begin, Begin) :- /* Note 7 */
                !,
	call(Goal).         /* *** what do we do for cuts */
dcg_body([], Begin, Begin) :- !. /* Note 8 */
dcg_body([Terminal|Tail], Begin, End) :- /* Note 9 */
                !,
        connects(Begin, Terminal, Middle),
	dcg_body(Tail, Middle, End).
dcg_body(NonTerminal, Begin, End) :- /* Note 10 */
	nonterminal(NonTerminal),
	dcg(NonTerminal, Begin, End).

nonterminal(NonTerminal) :-
	nonvar(NonTerminal),
	functor(NonTerminal, Symbol, _),
	atom(Symbol).

proper_list(List) :-
	nonvar(List),
	proper_list_1(List).

proper_list_1([]).
proper_list_1([_|List]) :-
	proper_list(List).


connects(List, Element, Leftover) :-
        'C'(List, Element, Leftover).
dcg_rule(Head,Body) :-
     --->(Head, Body).

%
% (X ---> Y), mix_to_procedure(dcg, X, Z), display_clause(Z), fail.
%    for partial evaluation
%

