/*  Copyright (C) 1989  Arun Lakhotia    */
/* File: context-down.pro
*  Author: Arun Lakhotia
*  $Log:	down.pro,v $
Revision 1.1  90/07/05  17:30:45  arun
New Release
      */

/*  INTERPRETER ENCODING CONTEXT-DOWN TECHNIQUE */

% context_down(+GOAL, +CONTEXT)
%    carries the CONTEXT down while executing GOAL

context_down((GoalA,GoalB), Context) :- !,
     context_down(GoalA, Context),
     context_down(GoalB, Context).
context_down(Goal, _Context) :-
     evaluate_direct(Goal), !,
     call(Goal).
context_down(Head, Context) :-
     unfold_clause(Head, Body),
     push_context_down(Head, Context, NewContext),
     context_down(Body, NewContext).


 /* ABSTRACT PREDICATES USED BY THE TECHNIQUE */

% push_context_down(+GOAL, +CONTEXT, -NEWCONTEXT) <-
%     computes a NEWCONTEXT from the CONTEXT received on unfolding a
%     GOAL. The NEWCONTEXT is used for the evaluation of the body of
%     the clause.
