/*  Copyright (C) 1989  Arun Lakhotia    */
/* File: context-up.pro
*  Author: Arun Lakhotia
*  $Log:	up.pro,v $
Revision 1.1  90/07/05  17:30:38  arun
New Release
      */

/*  INTERPRETER ENCODING CONTEXT-UP TECHNIQUE */

% context_up(+GOAL, -CONTEXT)
%      Returns CONTEXT from executing GOAL

context_up((GoalA,GoalB), Context) :- !,
	context_up(GoalA, FromA),
	context_up(GoalB, FromB),
	merge_context_at_conjunct((GoalA,GoalB), FromA, FromB, Context).
context_up(Goal, Context) :-
        evaluate_direct(Goal), !,
	call(Goal),
        context_after_direct_goal(Goal, Context).
context_up(Head, Context) :-
        unfold_clause(Head, Body),
	context_up(Body, FromBody),
        context_after_atomic_goal(Head, FromBody, Context).

 /* ABSTRACT PREDICATES USED BY THE TECHNIQUE */ 

% merge_context_at_conjunct(+GOALSAB, +FROMA, +FROMB, -CONTEXT) <-
%    merges the contexts FROMA and FROMB obtained from evaluating 
%    conjunctive GOALSAB and returns as CONTEXT.

% context_after_direct_goal(+GOAL, -CONTEXT) <-
%    computes the CONTEXT to be returned after evaluating a
%    GOAL directly by the Prolog engine.

% context_after_atomic_goal(+GOAL, +FROMBODY, -CONTEXT) <-
%     computes the CONTEXT after evaluating the GOAL for a
%     user-defined predicate. FROMBODY is the context obtained
%     from evaluating the body of a clause of GOAL.
