  credit(A,B) :- 
      ok_profile(A),
      clll_rating(A,C),
      financial_rating(A,D),
      bank_yield(A,E),
      evaluate(profile(C,D,E),B).
  clll_rating(A,B) :- clll_profile(A,C,D,E),clll_evaluation(C,D,E,B).
  clll_profile(A,B,C,D) :- 
      requested_credit(A,E),
      clll_percent(first_class,A,E,B),
      clll_percent(second_class,A,E,C),
      clll_percent(unliquid,A,E,D).
  financial_rating(A,B) :- 
      financial_factors(C),
      score(C,A,0,D),
      calibrate(D,B).
  score([(A,B)|C],D,E,F) :- 
      value(A,D,G),
      H is E+B*G,
      score(C,D,H,F).
  score([],A,B,B).
  evaluate(A,B) :- rule(C,B),verify(C,A).
  verify([condition(A,B,C)|D],E) :- 
      scale(A,F),
      select_value(A,E,G),
      compare(F,B,G,C),
      verify(D,E).
  verify([],A).
  select_value(clll,profile(A,B,C),A).
  select_value(finances,profile(A,B,C),B).
  select_value(yield,profile(A,B,C),C).
  compare(A,eq,B,B).
  compare(A,be,B,C) :- precedes(A,B,C).
  compare(A,we,B,C) :- precedes(A,C,B).
  precedes([A|B],A,C).
  precedes([A|B],C,D) :- A\==D,precedes(B,C,D).
  rule([condition(clll,be,excellent),condition(finances,be,good),condition(yield,be,reasonable)],full_amount).
  rule([condition(clll,eq,good),condition(finances,eq,good),condition(yield,be,reasonable)],half_request).
  rule([condition(clll,we,moderate),condition(finances,we,medium)],no_credit).
  clll_evaluation(A,B,C,excellent) :- A>=100.
  clll_evaluation(A,B,C,excellent) :- A>70,A+B>=100.
  clll_evaluation(A,B,C,good) :- 
      A+B>60,
      A+B<70,
      A+B+C>=100.
  clll(local_currency_deposits,first_class).
  clll(foreign_currency_deposits,first_class).
  clll(negotiate_instruments,second_class).
  clll(mortgage,unliquid).
  clll_percent(first_class,client1,50000,100.0).
  clll_percent(second_class,client1,50000,10.0).
  clll_percent(unliquid,client1,50000,24.0).
  calibrate(A,bad) :- A=<0-500.
  calibrate(A,medium) :- -500<A,A<150.
  calibrate(A,good) :- 150=<A,A<1000.
  calibrate(A,excellent) :- A>=1000.
  financial_factors([(net_worth_per_assets,5),(last_year_sales_growth,1),(gross_profits_on_sales,5),(short_term_debt_per_annual_sales,2)]).
  scale(clll,[excellent,good,moderate]).
  scale(finances,[excellent,good,medium,bad]).
  scale(yield,[excellent,reasonable,poor]).
  bank_yield(client1,excellent).
  requested_credit(client1,50000).
  value(net_worth_per_assets,client1,40).
  value(last_year_sales_growth,client1,20).
  value(gross_profits_on_sales,client1,45).
  value(short_term_debt_per_annual_sales,client1,9).
  ok_profile(client1).

