
/*
  % Basic Interpreter without count
  % It is adapted from
  %
  %  O'Keefe, R, "On the Treatment of Cuts in Prolog Source-Level
  %        Tools", Symposium on Logic Programming, Boston, 1985

solve(Goal) :-
     (Goal = true -> true
      ; Goal = (A,B) -> 
          solve(A), solve(B)
         ; sys(Goal) -> call(Goal)
         ; predicate_property(Goal, interpreted),
           clause(Goal, Body), solve(Body)
      ).
*/

/*  Above Interpreter Enhanced to Count */

count(Goal, Count) :-
     (Goal = true -> Count = 0
      ; Goal = (A,B) -> 
          count(A, C1), count(B, C2), Count is C1+C2
         ; sys(Goal) -> call(Goal), Count =1
         ; predicate_property(Goal, interpreted),
           clause(Goal, Body), count(Body, C1), Count is C1+1
      ).
