psolve(count(true,0), A-A).

psolve(count((A,B),C), D-E) :-
        psolve(count(A,F), D-G),
        psolve(count(B,H), G-I),
        psolve_prim(C is F+H, I-E).

psolve(count(A,B), C-D) :-
        \+suspend(count(A,B)),
        psolve(clause_o(A,E), C-F),
        psolve(count(E,G), F-H),
        psolve_prim(B is G+1, H-D).

psolve(count(A,0), B-C) :-
        \+suspend(count(A,0)),
        psolve(built_in(A), B-D),
        psolve_prim(call(A), D-C).

psolve(count(A,B), [count(A,B)|C]-C) :-
        suspend(count(A,B)).

psolve(clause_o(append([],A,A),true), B-B).

psolve(clause_o(append([A|B],C,[A|D]),append(B,C,D)), E-E).

psolve(built_in(A is B), C-C).

psolve(built_in(A=:=B), C-C).

psolve(built_in(A=\=B), C-C).

psolve(built_in(A<B), C-C).

psolve(built_in(A=<B), C-C).

psolve(built_in(A>B), C-C).

psolve(built_in(A>=B), C-C).

psolve(built_in(call(A)), B-B).

