
psolve(A,R) :- 
    unfold_clause(A,B),
    psolve1(B,R).

psolve1(true, Z-Z).
psolve1((A,B),X-Z) :-
    psolve1(A,X-Y),
    psolve1(B,Y-Z).
psolve1(A,R) :- 
    built_in(A),         % implicitly  \+ conjunction(A), \+ A = true.
    psolve_prim(A,R).
psolve1(A,R) :- 
    \+ conjunction(A),
    \+(A = true),
    \+built_in(A),
    psolve3(A,R).

psolve3(A,R) :- 
    unfold_clause(A,B),
    expandable(A),
    psolve1(B,R).
psolve3(A,[A|Z]-Z) :-
    residual(A).

conjunction((_A,_B)).

expandable(A) :- \+suspend(A).
residual(A) :- suspend(A).

psolve_prim(A is B,Z-Z) :- ground(B), !, call(A is B).
psolve_prim(A is B,[A is B|Z]-Z) :- !.

psolve_prim(A =:= B,Z-Z) :- ground(B), !, call(A =:= B).
psolve_prim(A =:= B,[A =:= B|Z]-Z) :- !.

psolve_prim(A =\= B,Z-Z) :- ground(B), !, call(A =\= B).
psolve_prim(A =\= B,[A =\= B|Z]-Z) :- !.

psolve_prim(A < B,Z-Z) :- ground(B), !, call(A < B).
psolve_prim(A < B,[A < B|Z]-Z) :- !.

psolve_prim(A =< B,Z-Z) :- ground(B), !, call(A =< B).
psolve_prim(A =< B,[A =< B|Z]-Z) :- !.

psolve_prim(A > B,Z-Z) :- ground(B), !, call(A > B).
psolve_prim(A > B,[A > B|Z]-Z) :- !.

psolve_prim(A >= B,Z-Z) :- ground(B), !, call(A >= B).
psolve_prim(A >= B,[A >= B|Z]-Z) :- !.

psolve_prim(call(A),Z-Z) :- ground(A), !, call(A).
psolve_prim(call(A),[A|Z]-Z) :- !.
