copy(_X,_Y) :- cp(_X,_Y,_L).
% Dollar is prefixed. Ascii value of $ is 36 ...
cp(X,Y,L) :- compound(X),functor(X,F,N),name(F,FL),cp_append([36],FL,FD),
             name(Fnew,FD),functor(Y,Fnew,N),copy_args(X,Y,N,L-[]).

copy_args(_X,_Y,0,_L-_L):-!.
copy_args(X,Y,N,L-M):-arg(N,X,Argx),
		  arg(N,Y,Argy),
		  copy_arg(Argx,Argy,Larg-M),
		  N1 is N - 1,
		  spec_append(Larg,M,LargM),
		  copy_args(X,Y,N1,L-LargM).

copy_arg(X,Y,[]-_M):-nonvar(X),Y=X.
copy_arg(X,Y,[X/Y]-M):-var(X),not_in(X,M,_K),X \== Y.
copy_arg(X,Y,[]-M):-var(X),in(X,M,K),Y = K.
copy_arg(X,Y,L-_M):-cp(X,Y,L).

not_in(_X,[],_K).
not_in(X,[Y/_|T],K):-X \== Y,not_in(X,T,K).

in(_X,[],_K):-fail.
in(X,[Z/Y|_T],Y):-X == Z.
in(X,[Y/_|T],K):-X \== Y,in(X,T,K). 

compound(X) :- \+atomic(X),\+var(X),functor(X,_,_).

spec_append([],Xs,Xs).  
spec_append([X/Y|Xs],Ys,[X/Y|Zs]):-cp_append(Xs,Ys,Zs).  


cp_append([],List2,List2).
cp_append([X|Xs],List2,[X|Zs]) :- cp_append(Xs,List2,Zs).
