/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: defsystem.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:44:15 CDT 1990
*   $Log:	defsystem.pro,v $
**   Revision 1.4  90/07/05  17:26:18  arun
**   New Release
**   
**   Revision 1.3  89/04/17  18:23:45  arun
**   nothing much
**   
**   Revision 1.2  89/04/17  17:34:33  arun
**   Included the new files created to support loop-check feature
**   in the defsystem.
**   
**   Revision 1.1  89/04/16  01:43:22  arun
**   Initial revision
**         */

  :- current_op(X, Y, =), op(X, Y, /=).

   :- multifile help_param/4.

  defsystem(promix,
       '~/src/',
    [
/*	 % loaded explicitly during startup. Maintained here
	 % for the benefit of other program transformation or
	 % manipulation tools.
*/
         preloaded([ 
          defsystem,	   /*   This file .. */
	  './startup',	   /*  Initial startup file to boot ProMiX */
          'port/sicstus'   /*  Implementation specific files */
			   /*    Default: SICStus Prolog */
%           'port/cprolog',
%           'port/sys'
	 ]), 

	module(kernel),	   /*   The pe engine */
/*    %	module('kernel-nocut'),   %  PE engine (does not handle cut)
*/
	module(driver),	   /*  Driver for specializing interpreters */
	module(rules),	   /*  Unfold and rewrite rules for specialzing */
			   /* interpreters */
	module(utility)	   /*  General purpose support library */
     ]).

  defmodule('kernel-nocut', 
        '~/src/kernel-nocut/', /*  Version WITHOUT cut processing */
	[declare,
	  mix,             /*  generate residue for a goal   */
	  meta,            /*   -- meta predicates ;/2 ->/2 call/1 /+ */
	  set,             /*   -- set predicates findall/3, bagof/3, setof/3 */
	  residue          /*  Data abstraction for Residue structure */
      ]).

  defmodule(kernel, 
        '~/src/kernel/',   /*  Version handling cut */
	[declare,
	  mix,             /*  generate residue for a goal   */
	  meta,            /*   -- meta predicates ;/2 ->/2 call/1 /+ */
	  set,             /*   -- set predicates findall/3, bagof/3, setof/3 */
	  residue          /*  Data abstraction for Residue structure */
      ]).

  defmodule(driver,
	'~/src/driver/',

       [ main,
	driver,          /*  driver for ProMiX */
	rewrite,         /*  rewrite predicate names in residue */
	meta_goal        /*  procedures to access meta-knowledge */
      ]).

  defmodule(rules, 
	 '~/src/rules/',
	[criterion,        /*  default unfolding criterion */
	 expand_predicate, /*  default expand_predicate/2  */
	 knowledge,        /*  knowledge about evaluable system predicates */
	 memo,             /*  support to memo rewrite relations */
         loop	           /*  test for looping */
	]).

  defmodule(utility,
	'~/src/utility/',
       [
	 util,             
	 allpred,	   /*  extract predicates define in files */
	 clause,	   /*  manipulate clauses */
	 io,		   /*  display clause and read files */
	 system,	   /*  definition of system and meta predicates */
	 atom,		   /*  manipulate atoms */
	 list,             /*  predicates manipualting lists */
	 tryhard,	   /*  search for file in a directory path */
	 symbolvars,	   /*  generate symbolic names for variables */
			   /*    used to display clause   */
         parameters        /*  get/set/help for ProMiX parameters */

     ]).

   defmodule(virtual,
	'~/src/port/virtual/',
	[ consult_data,	   /*  Virtual database support */
          prolog_metai	   /*  Evaluate (call/1) programs in virtual database */
         ]).


/*%% END OF DEFSYSTEM.PRO %%
*/

