/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: main.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:44:35 CDT 1990
*   $Log:	main.pro,v $
**   Revision 1.2  90/07/05  17:22:13  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:31:11  arun
**   Initial revision
**         */
/*
*  MAIN ENTRY POINTS FOR SPECIALIZING INTERPRETERS
*/

/*     ENTRY POINTS : 
%%
%%        mixf(+FLAVOR, +FILE(S))
%%
%%        mixv(+FLAVOR, +FILE(S))
%%           Mixes FLAVOR to variable meta argument. Useful when the
%%           interpreters input is in two parts - one a Prolog
%%           program and the other some argument. (See palindrome and
%%           dcg for example).
*/

  /***** MIXING TO A FLAVOR WITH VARIABLE ARGUMENTS  ***/

%        mixv(+FLAVOR, +FILE(S))

  mixv(Flavor, DataFiles) :-
       reconsult_data_files(DataFiles),
       mix_to_flavor(Flavor, [_Var]).  

  /****** INTERFACE FOR MIXING TO A LIST OF FILES ****/

% mixf(+FLAVOR, +FILES)

  mixf(_Flavor, Files) :-
       \+ ground(Files),
       writeln(['ERROR: Variable given for a file or files']),
       !,fail.
  mixf(Flavor, Files) :-
      reconsult_data_files(Files),
      mixf_x(Flavor, Files).

  mixf_x(_Flavor, []) :-!.
  mixf_x(Flavor, [File|Files]) :- !,
      mixf_x(Flavor, File),
      mixf_x(Flavor, Files).
  mixf_x(Flavor, File) :-
      preds_in_file(File, PredList-[]), !,
      mix_to_flavor(Flavor, PredList).

  mix_to_flavor(Flavor, PredList) :-
     meta_goal(Flavor, IntGoal, MetaArg),
     mix_and_output(IntGoal, MetaArg, PredList),
     fail.
  mix_to_flavor(_Flavor, _PredList).


  /* END OF MAIN.PRO */
