/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: BIMprolog.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:45:02 CDT 1990
*   $Log:	BIMprolog.pro,v $
**   Revision 1.2  90/07/05  17:24:02  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:33:53  arun
**   Initial revision
**         */

:- op(900, fx, not).
:- op(900, fx, spy).
:- op(900, fx, nospy).

length([], 0).
length([X|Xs], N1) :- length(Xs, N), N1 is N+1 .
	
fileerrors.
nofileerrors.

/*% findall(X, Generator, Bag).
*/
findall(X, Y, Z) :- bagof(X, Y^Y, Z),!.
findall(_X, _Y, []).

member(X,[X|_]).
member(X,[_|Xs]) :- member(X,Xs).

append([X|Xs],Ys,[X|Zs]) :- append(Xs,Ys,Zs).
append([],Xs,Xs).

/*%  ground/1 is predefined in BIM_Prolog
*/

writeln([]) :- nl.
writeln([X|Xs]) :- write(X), writeln(Xs).

/*% see_if_file_exists(+Filename)
*/
see_if_file_exists(X) :-
      see(X).

consult_program(File) :- consult(File).
reconsult_program(File) :- reconsult(File).

consult_data(Files) :- 
    append_atoms('-a ', File, Fd),
    consult(Fd).
reconsult_data(Files) :- 
    append_atoms('-a ', File, Fd),
    reconsult(Fd).

unfold_data(A, B) :- clause(A, B).

/*% tabs_hook(+NUM)
*/
   tabs_hook(X) :- spaces(X).

/*% read_hook(+TERM)
*/
   read_hook(X) :- read(X), !.
   read_hook(end_of_file).

/*% call_hook(+GOAL)
*/
   call_hook(clause(X,Y)) :- !, unfold_clause(X,Y).
   call_hook(Goal) :- call(Goal).

/*% lt_hook(+X, +Y)
*/
   lt_hook(X, Y) :- X < Y.

/*% gt_hook(+X, +Y)
*/
   gt_hook(X, Y) :- X > Y.

/*% name_hook(NAME, STRING) 
*/
   name_hook(Name, String) :- name(Name, String).

/*% copy_hook(+TERM1, -TERM2)
*/
   copy_hook(X,Y) :- asserta('#$$'(X)),retract('#$$'(Y)).


/*%%  END OF BIM_PROLOG.PRO %%*/
