/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: alspro.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:45:07 CDT 1990
*   $Log:	alspro.pro,v $
**   Revision 1.2  90/07/05  17:24:05  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:33:53  arun
**   Initial revision
**         */

:- current_op(X, Y, (not)), op(X, Y, (dynamic)).
dynamic(X).

fileerrors.
nofileerrors.

/*% abolish(+Predicate).
%    This implementation may not be standard. 
%      a) it allows f/n and p(t1, ..,tn) both definition
%      b) in case of latter definition it would only remove clauses
%         whose heads unify with the given input predicate
*/
abolish(Predicate) :-
   pred_in_normalform(Predicate, Head),
   retract_all_clauses(Head).

abolish(F, N) :-
   abolish(F/N).

/*% findall(X, Generator, Bag).
*/
findall(X, Y, Z) :- bagof(X, Y^Y, Z).

/*% see_if_file_exists(+Filename)
*/
see_if_file_exists(X) :-
      see(X).

file_exists(File) :-
  see(File),
  seen,!.
file_exists(_File) :-
  fail.

make_not(X, not(X)) :-!.
make_not(X, \+(X)).

member(X,[X|_]).
member(X,[_|Xs]) :- member(X,Xs).

append([X|Xs],Ys,[X|Zs]) :- append(Xs,Ys,Zs).
append([],Xs,Xs).

ground(Term) :- atomic(Term),!.
ground(Term) :- functor(Term,_,N),!,ground(N,Term).
ground(N,Term) :- N>0,!,arg(N,Term,T),ground(T),N1 is N-1,ground(N1,Term).
ground(0,_).

writeln([]) :- !,
    nl.
writeln([X|Xs]) :-
    write(X),
    writeln(Xs).

consult_program(File) :- compile(File).
reconsult_program(File) :- compile(File).

consult_data(Files) :- consult(Files).
reconsult_data(Files) :- reconsult(Files).

unfold_data(A, B) :- clause(A, B).

/*%    is_compiled(+GOAL)
%    is_interpreted(+GOAL)
%    is_built_in(+GOAL).
*/

     is_compiled(_Goal) :-
           fail.
     is_built_in(Goal) :-
          sysp(Goal).
     is_interpreted(Goal) :-
          predicate_property(Goal, interpreted).

/*% tabs_hook(+NUM)
*/
   tabs_hook(X) :- tab(X).

/*% read_hook(+TERM)
*/
   read_hook(X) :- read(X).

/*% call_hook(+GOAL)
*/
   call_hook(clause(X,Y)) :-!, unfold_clause(X,Y).
   call_hook(Goal) :- call(Goal).

/*% lt_hook(+X, +Y)
*/
   lt_hook(X, Y) :- X < Y.

/*% gt_hook(+X, +Y)
*/
   gt_hook(X, Y) :- X > Y.

/*% name_hook(NAME, STRING) 
*/
   name_hook(Name, String) :- name(Name, String).

/*% copy_hook(+TERM1, -TERM2)
*/
   copy_hook(X,Y) :- asserta('#$$'(X)),retract('#$$'(Y)).


/*%% END OF ALSPRO.PRO %%%*/
