/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: quintus.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:45:27 CDT 1990
*   $Log:	quintus.pro,v $
**   Revision 1.3  90/08/21  12:03:26  arun
**   Disabled the use of 'dynaload.pro' file. Should use the
**   virtual database at all time when using ProMiX with Quintus.
**   Disabling done by commenting the code that was giving 
**   `redefinition' warnings and changing the startup.pro
**   
**   Revision 1.2  90/07/05  17:23:50  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:33:57  arun
**   Initial revision
**         */

:- current_op(X,Y,\+), op(X, Y, not).

not(X) :- \+ X.

findall(X, Y, Z) :- bagof(X, Y^Y, Z),!.
findall(_X, _Y, []).

make_not(X, \+X) :-!.
make_not(X, not(X)).

/*% see_if_file_exists(+Filename)
*/
see_if_file_exists(X) :-
      see(X).

file_exists(File) :-
  nofileerrors,
  see(File),
  seen,!,
  fileerrors.
file_exists(_File) :-
  fileerrors, fail.

member(X,[X|_]).
member(X,[_|Xs]) :- member(X,Xs).

append([],Xs,Xs).
append([X|Xs],Ys,[X|Zs]) :- append(Xs,Ys,Zs).

ground(Term) :- atomic(Term),!.
ground(Term) :- functor(Term,_,N),!,ground(N,Term).
ground(N,Term) :- N>0,!,arg(N,Term,T),ground(T),N1 is N-1,ground(N1,Term).
ground(0,_).

writeln([]) :- !,
    nl.
writeln([X|Xs]) :-
    print(X),                  /*  changed from write(X) 10/2/88 */
    writeln(Xs).

consult_program(File) :- consult(File).
reconsult_program(File) :- consult(File).

%consult_data(Files) :- dynaload(Files).
%reconsult_data(Files) :- dynaload(Files).

%unfold_data(A, B) :- clause(A, B).

/*%    is_compiled(+GOAL)
%    is_interpreted(+GOAL)
%    is_built_in(+GOAL).
*/

     is_compiled(Goal) :-
          predicate_property(Goal, compiled).
     is_interpreted(Goal) :-
          predicate_property(Goal, interpreted).
     is_built_in(Goal) :-
          predicate_property(Goal, built_in).

/*% tabs_hook(+NUM)
*/
   tabs_hook(X) :- tab(X).

/*% read_hook(+TERM)
*/
   read_hook(X) :- read(X).

/*% call_hook(+GOAL)
*/
%   call_hook(Goal) :- call(Goal).

/*% lt_hook(+X, +Y)
*/
   lt_hook(X, Y) :- X < Y.

/*% gt_hook(+X, +Y)
*/
   gt_hook(X, Y) :- X > Y.

/*% name_hook(NAME, STRING) 
*/
   name_hook(Name, String) :- name(Name, String).

/*% copy_hook(+TERM1, -TERM2)
*/

   copy_hook(X,Y) :- asserta('#$$'(X)),retract('#$$'(Y)).

/* probably not defined in some versions */

   retractall(X) :- retract(X), fail.
   retractall(X).

/*%% END OF QUINTUS.PRO %%%*/
