/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: sbprolog.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:45:30 CDT 1990
*   $Log:	sbprolog.pro,v $
**   Revision 1.2  90/07/05  17:23:53  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:33:58  arun
**   Initial revision
**         */

findall(X, Y, Z) :- bagof(X, Y^Y, Z),!.
findall(_X, _Y, []).

fileerrors.
nofileerrors.

file_exists(File) :- '$exists'(File).

make_not(X, \+X) :-!.
make_not(X, not(X)).

/*% see_if_file_exists(+Filename)
*/
see_if_file_exists(X) :-
      file_exists(X),
      see(X).

member(X,[X|_]).
member(X,[_|Xs]) :- member(X,Xs).

append([],Xs,Xs).
append([X|Xs],Ys,[X|Zs]) :- append(Xs,Ys,Zs).

ground(Term) :- atomic(Term),!.
ground(Term) :- functor(Term,_,N),!,ground(N,Term).
ground(N,Term) :- N>0,!,arg(N,Term,T),ground(T),N1 is N-1,ground(N1,Term).
ground(0,_).

writeln([]) :- !,
    nl.
writeln([X|Xs]) :-
    print(X),                  /*  changed from write(X) 10/2/88 */
    writeln(Xs).

reconsult(X) :- consult(X, [v]).

consult_program(File) :- consult(File).
reconsult_program(File) :- reconsult(File).

/* consult_data(X) definition taken from consult_data.pro */
/*% tabs_hook(+NUM)
*/
   tabs_hook(X) :- tab(X).

/*% read_hook(+TERM)
*/
   read_hook(X) :- read(X).

/*% call_hook(+GOAL)
*/
   call_hook(Goal) :- call(Goal).

/*% lt_hook(+X, +Y)
*/
   lt_hook(X, Y) :- X < Y.

/*% gt_hook(+X, +Y)
*/
   gt_hook(X, Y) :- X > Y.

/*% name_hook(NAME, STRING) 
*/
   name_hook(Name, String) :- name(Name, String).

/*% copy_hook(+TERM1, -TERM2)
*/
   copy_hook(X,Y) :- asserta('#$$'(X)),retract('#$$'(Y)).


/*%% END OF SBPROLOG.PRO %%*/
