/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: sicstus.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:45:34 CDT 1990
*   $Log:	sicstus.pro,v $
**   Revision 1.2  90/07/05  17:23:56  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:33:59  arun
**   Initial revision
**         */

/*%%
%% Definitions for PORTING ProMiX TO SICStus Prolog
%%
*/

  :- current_op(X, Y, \+), op(X, Y, not).

/*%  file_exists(+FILE)
%     succeeds if FILE exists else fails
*/

  file_exists(File) :-
    nofileerrors,
    see(File),
    seen,!,
    fileerrors.
  file_exists(_File) :-
    fileerrors, fail.


/*%  make_not(?GOAL, ?NOT_GOAL)
%    Creates NOT_GOAL by wrapping the structure for not arounf GOAL.
%    or extracts GOAL from NOT_GOAL
*/

  make_not(X, \+(X)) :-!.
  make_not(X, not(X)).

/*% see_if_file_exists(+FILE)
%    open FILE to see if its exists else fail
*/

  see_if_file_exists(FILE) :-
	see(FILE).

/*% member(?X, +LIST)
*/
  member(X,[X|_]).
  member(X,[_|Xs]) :- member(X,Xs).

/*% append(+X, +Y, -Z)  (common usage)
*/
  append([X|Xs],Ys,[X|Zs]) :- append(Xs,Ys,Zs).
  append([],Xs,Xs).

/*% ground(+TERM)
*/
  ground(Term) :- atomic(Term),!.
  ground(Term) :- functor(Term,_,N),!,ground(N,Term).
  ground(N,Term) :- N>0,!,arg(N,Term,T),ground(T),N1 is N-1,ground(N1,Term).
  ground(0,_).

/*%  writeln(LIST)
*/
  writeln([]) :- !,
      nl.
  writeln([X|Xs]) :-
      print(X),                  /*  changed from write(X) 10/2/88 */
      writeln(Xs).

/*%  consult_program(+FILE)
%  reconsult_program(+FILE)
*/
  consult_program(File) :- consult(File).
  reconsult_program(File) :- reconsult(File).

/*%  consult_data(+FILE)
%  reconsult_data(+FILE)
*/
  consult_data(File) :- consult(File).
  reconsult_data(File) :- reconsult(File).

   unfold_data(A, B) :- clause(A, B).

/*%    is_compiled(+GOAL)
%    is_interpreted(+GOAL)
%    is_built_in(+GOAL).
*/

     is_compiled(Goal) :-
          predicate_property(Goal, compiled).
     is_interpreted(Goal) :-
          predicate_property(Goal, interpreted).
     is_built_in(Goal) :-
          predicate_property(Goal, built_in).

/*% tabs_hook(+NUM)
*/
   tabs_hook(X) :- tab(X).

/*% read_hook(+TERM)
*/
   read_hook(X) :- read(X).

/*% call_hook(+GOAL)
*/
   call_hook(Goal) :- call(Goal).

/*% lt_hook(+X, +Y)
*/
   lt_hook(X, Y) :- X < Y.

/*% gt_hook(+X, +Y)
*/
   gt_hook(X, Y) :- X > Y.

/*% name_hook(NAME, STRING) 
*/
   name_hook(Name, String) :- name(Name, String).

/*% copy_hook(+TERM1, -TERM2)
*/
   copy_hook(Term1, Term2) :- copy_term(Term1, Term2).

/*%% END OF SICSTUS.PRO %%%*/
