/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: copy.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:43:00 CDT 1990
*   $Log:	copy.pro,v $
Revision 1.1  90/07/05  17:24:34  arun
New Release

*/

 % copy(+TERM1, -TERM2)
 %     creates TERM2 a copy of TERM1 with variables renamed
 %     This copy predicate does not use assert/retract but instead
 %     it traverses the term and does the copying.
 %     This refied version is useful when partially evaluating a program
 %     that uses copy/2
 %   This file contains all the definitions necessary and is thus self-conent

     copy(Term1, Term2) :-
	copy(Term1, Term2, [], _Dict).

     copy(Var1, Var2, InDict, OutDict) :-
         var(Var1),
         put_in_dict(InDict, OutDict, Var1, Var2).
     copy(Term1, Term2, InDict, OutDict) :-
       functor(Term1, Functor, Arity),
       functor(Term2, Functor, Arity),
       copy_x(Arity, Term1, Term2, InDict, OutDict).
   
     copy_x(0, _Term1, _Term2, InDict, InDict).
     copy_x(NthArg, Term1, Term2, InDict, OutDict) :-
	   NthArg > 0,
	   arg(NthArg, Term1, A1),
	   arg(NthArg, Term2, A2),
	   copy(A1, A2, InDict, MidDict),
	   N1 is NthArg -1,
	   copy_x(N1, Term1, Term2, MidDict, OutDict).

 % put_in_dict(+INDICTHEAD, +INDICTTAIL, +VARIABLE, -RENAMEDVARIABLE)
 %   predicate local to copy/2

    put_in_dict(InDict, InDict, Var1, Var2) :-
       put_in_dict_x(InDict, Var1, Var2),!.
    put_in_dict(InDict, [Var1-Var2|InDict], Var1, Var2).

    put_in_dict_x([OldVar-MatchVar|_Dict], Var1, MatchVar) :-
         OldVar == Var1,!.
    put_in_dict_x([_X|Dict], Var1, Var2) :-
         put_in_dict_x(Dict, Var1, Var2).
