/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: criterion.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:40:31 CDT 1990
*   $Log:	criterion.pro,v $
**   Revision 1.2  90/07/05  17:22:33  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:30:04  arun
**   Initial revision
**         */
/*
*   META-KNOWLEDGE REQUIRED FOR SPECIALIZING INTERPRETERS 
*      See examples and attached documentations for details
*
* About Interpreter
*   meta_goal(Goal, MetaArg)
* About Language
*   structure_decomposed(Struct)
*   terminal_atom(Arg)
* About support procedures
*   imperative(Goal)
*   export(Goal)
*   immediate(Goal)
* For driver
*   flavor(Flavor, Predicate)
*   rule_head(Term, Head)
*/

%  should_unfold(+GOAL)
%      succeeds if a GOAL is instantiated enough to be unfolded

  should_unfold(Goal) :-
       meta_goal(Goal, MetaArg),!,
       ( structure_decomposed(MetaArg)
	; terminal_atom(MetaArg)).
  should_unfold(Goal) :- imperative(Goal),!.
  should_unfold(Goal) :- 
       \+ export(Goal),
       \+ immediate(Goal).

  /*  END OF CRITERION.PRO */
