/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: expand_predicate.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:40:34 CDT 1990
*   $Log:	expand_predicate.pro,v $
**   Revision 1.2  90/07/05  17:22:37  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:30:05  arun
**   Initial revision
**         */

/* CHANGES
*    February 18, 1990 by AL
*     Fix for problem with evaluating goal in virtual database
*     Replaced is_built_in/1 with is_primitive/1
*/

/*
*    Created: Jan 21, 1989
*
*    Contains various rules used by the partial evaluator
*    These rules need to be changed to effect the behavior of 
*    the partial evaluator or residue
*/

  expand_predicate(Goal, RGoal) :- 
     get_meta_argument(Goal, ObjGoal),
     nonvar(ObjGoal),
     rewrite_relation(Goal, RGoal),!.
  expand_predicate(Goal, RGoal) :-
     is_meta_goal(Goal),
     create_goal_template(Goal, GMetaGoal),
     rewrite_rule(GMetaGoal, RGoal),
     store_rewrite_relation(GMetaGoal, RGoal),
     GMetaGoal = Goal.

    rewrite_rule(MetaGoal, RewrittenGoal) :-
         get_meta_argument(MetaGoal, ObjGoal),
         rewrite_rule(MetaGoal, ObjGoal, RewrittenGoal).

    rewrite_rule(MetaGoal, ObjGoal, MetaGoal) :- 
	retain_meta_goal(ObjGoal),!.
    rewrite_rule(MetaGoal, ObjGoal, NewObjGoal) :- 
        get_rest_arguments(MetaGoal, MetaArgs),
        get_goal_arguments(ObjGoal, ObjArgs),
        merge_arguments(ObjArgs, MetaArgs, NewObjArgs),
	generate_functor_name(MetaGoal, ObjGoal, NewFunctName),
        NewObjGoal =.. [NewFunctName|NewObjArgs].

   merge_arguments(ObjArgs, MetaArgs, NewObjArgs) :-
        append(ObjArgs, MetaArgs, NewObjArgs).

   generate_functor_name(_MetaGoal, ObjGoal, Functor) :-
        ObjGoal =.. [Functor|_ObjArgs].


retain_meta_goal(Goal) :-
   (var(Goal)
    ; is_primitive(Goal)
 /*%   ; is_dynamic(Goal)  % predicates defined as ":- dynamic "
    ; undefined(Goal)
 */
   ),!.


