/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: memo.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:40:44 CDT 1990
*   $Log:	memo.pro,v $
**   Revision 1.2  90/07/05  17:22:30  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:30:06  arun
**   Initial revision
**         */

/*  %%  SUPPORT FOR MEMOING REWRITE RELATION
*/

  :- dynamic '#$$rewrite'/2.

/*%   clean_rewrite_relation
*/

  clean_rewrite_relation :-
      retractall('#$$rewrite'(_From, _To)).

/*%   store_rewrite_relation(+FROM, +TO)
*/

  store_rewrite_relation(From, To) :-
      rewrite_relation(From, To) 
      -> true                              /*  translation already exists */
      ;  From == To
	 -> true                           /*  no translation done */
	 ; assert('#$$rewrite'(From, To)). /*  store translation */

/*%  rewrite_relation(?FROM, ?TO)
*/

  rewrite_relation(From, To) :-
       '#$$rewrite'(From, To).

/*%  list_rewrite_relation
*/

  list_rewrite_relation :-
     writeln([' /* Rewrite relations used  */']),nl, 
       setof_rewrite_relations(Relations),
     display_clauses(Relations),
     fail.
  list_rewrite_relation.

/*%  setof_rewrite_relations(-REWRITES)
%     setof REWRITES clauses generated
*/

 setof_rewrite_relations(Rewrites) :-
    findall((From:-To), rewrite_relation(From,To), Rewrites).


/*%% END OF MEMO.PRO %%*/
