/*  Copyright (C) 1989,90  Arun Lakhotia    */
/* File: atom.pro
*  Author: Arun Lakhotia
*  Released:  Thu Jul 5 16:37:40 CDT 1990
*   $Log:	atom.pro,v $
**   Revision 1.2  90/07/05  17:23:20  arun
**   New Release
**   
**   Revision 1.1  89/04/16  01:23:05  arun
**   Initial revision
**         */
/*
*   Purpose: Collect utilities related to operations
*      on Prolog atom structure
*
*/

/*%  append_atom_list(+ATOMS, -ONEATOM)
%    Concatenates a list of ATOMS into ONEATOM
*/

  append_atom_list([], ''):-!.
  append_atom_list([X], X) :-!.
  append_atom_list([A|As], Res) :-
      append_atom_list(As, Rs),
      append_atoms(A, Rs, Res).

/*% name_list(+ATOMS, -STRINGS
%     Converts a list of ATOMS into a list of STRINGS
*/

  name_list([], []).
  name_list([A|As], [X|Xs]) :-
	  name_hook(A, X),
	  name_list(As, Xs).

/*%%% END OF ATOM.PRO %%%%*/
